<template lang="pug">

.container(v-loading="pageLoading")
  h4.mb-10 Основной банер
  .block-typical
    el-form.cascad-form(
      ref='homePageForm'
      v-if="inputs.length"
      :model='stateForm'
      :rules="rules")

      el-form-item(
        v-for="item in inputs"
        :key="item.id"
        :prop="item.name"
        v-if='item.name !== "photo"')

        app-input(
        :placeholder="item.placeholder"
        :model="stateForm[item.name]"
        :name="item.name"
        :id="item.id"
        :label="item.label"
        :type="item.type"
        :prompt="item.prompt"
        :autosize="item.autosize"
        :required="item.required"
        @input-value="modelValue")

      el-form-item(
        prop='photo')

        app-uploader(
          label="Фото"
          :photo="page.photo"
          :uploadForm="uploadForm"
          :uploadFormHost="uploadFormHost"
          :readyToShip='readyToShip'
          @success-upload="successUpload"
          @remove-photo="removePhoto"
          @change-photo="changePhoto")

      .flex-form

        el-form-item(style="max-width:200px; min-width:100px")
          span.input__label.input__label_active Цвет текста
          el-color-picker(
            v-model='color'
            show-alpha)

        el-form-item(style="max-width:200px; min-width:100px")
          span.input__label.input__label_active Цвет фона банера
          el-color-picker(
            v-model='colorBG'
            show-alpha)

  .activity__block
    router-link.el-button.el-button--info.button(
    :to="{path: '/admin'}")
      |Отмена

    el-button.button(
    type="success"
    @click="updateMainPage('homePageForm')")
      |Сохранить изменения


</template>

<script>
import InputItem from '../../components/InputItem';
import Uploader from '../../components/admin/Uploader';

export default {
  layout: 'admin',
  name: 'Main',
  components: {
    'app-input': InputItem,
    'app-uploader': Uploader
  },
  async asyncData(app) {
    let { data } = await app.$axios.get('/api/v1/home');
    return { page: data[0] };
  },
  data() {
    return {
      color: '#fcf6dc',
      colorBG: '#000',
      uploadFormHost: `${this.$store.state.baseURL}/api/v1/img`,
      deletePhotoPath: '',
      readyToShip: false,
      uploadForm: {
        path: 'pages/main'
      },
      inputs: [
        {
          id: 1,
          placeholder: 'Измените заголовок на подходящий',
          model: '',
          label: 'Заголовок',
          name: 'heading',
          required: true,
          prompt: 'Доступна html разметка',
          prop: [
            {
              required: true,
              message: 'Пожалуйста, заполните поле',
              trigger: 'change'
            }
          ]
        },
        {
          id: 2,
          placeholder: 'Укажите подходящий текст',
          model: '',
          label: 'Промо текст',
          name: 'text',
          type: 'textarea',
          autosize: { minRows: 1, maxRows: 20 },
          prompt: 'Доступна html разметка',
          required: true,
          prop: [
            {
              required: true,
              message: 'Пожалуйста, заполните поле',
              trigger: 'change'
            }
          ]
        },
        {
          id: 3,
          placeholder: 'Укажите ссылку на картинку',
          model: '',
          label: 'Картинка',
          name: 'photo',
          required: true,
          prop: [
            {
              required: true,
              message: 'Пожалуйста, добавьте картинку',
              trigger: 'change'
            }
          ]
        }
      ],
      pageLoading: false
    };
  },
  computed: {
    stateForm() {
      let state = {};
      this.inputs.forEach(item => {
        state[item.name] = this.page[item.name];
      });
      return state;
    },
    rules() {
      let rulesObj = {};
      this.inputs.forEach(item => {
        rulesObj[item.name] = item.prop;
      });
      return rulesObj;
    }
  },
  created() {
    this.$store.commit('pages', []);
    this.$store.commit('headingTitle', 'Главная страница');
    this.$store.commit('publicLink', '/');
    this.$store.commit('id', null);
  },
  mounted() {
    this.color = this.page.promoTextColor || '#fcf6dc';
    this.colorBG = this.page.promoBackgroundColor || 'rgba(228, 228, 228, 1)';
    this.inputs.forEach(item => {
      item.model = this.page[item.name];
    });
  },
  methods: {
    changePhoto(value) {
      this.page.photo = value;
    },
    successUpload(response) {
      if (response.photo) {
        this.$axios
          .patch('/api/v1/home', {
            heading: this.stateForm.heading,
            text: this.stateForm.text,
            photo: response.photo,
            promoTextColor: this.color,
            promoBackgroundColor: this.colorBG
          })
          .then(
            data => {
              this.page = data.data;
              if (this.deletePhotoPath) {
                this.$axios
                  .delete(`/api/v1/img?photo=${this.deletePhotoPath}`)
                  .then(
                    () => {
                      this.deletePhotoPath = '';
                      this.pageLoading = false;
                      this.$message.success(
                        'Главная страница успешно изменена!'
                      );
                    },
                    err => {
                      this.$message.error(err);
                    }
                  );
              } else {
                this.deletePhotoPath = '';
                this.pageLoading = false;
                this.$message.success('Главная страница успешно изменена!');
              }
            },
            errorMessage => {
              console.log(errorMessage);
              this.$message.error('Ошибка перезаписи данных!');
              this.pageLoading = false;
            }
          )
          .catch(() => {
            this.$message.error('Ошибка перезаписи данных');
            this.pageLoading = false;
          });
      }
    },
    removePhoto(value) {
      this.deletePhotoPath = value;
      this.page.photo = '';
    },
    modelValue(valueArr) {
      let index = this.inputs.findIndex(item => item.id === valueArr[0]);
      this.page[this.inputs[index].name] = valueArr[1];
    },
    updateMainPage(formName) {
      this.$refs[formName].validate(valid => {
        if (valid) {
          this.pageLoading = true;
          if (this.deletePhotoPath) {
            this.readyToShip = true;
          } else {
            this.$axios
              .patch('/api/v1/home', {
                heading: this.stateForm.heading,
                text: this.stateForm.text,
                photo: this.stateForm.photo,
                promoTextColor: this.color,
                promoBackgroundColor: this.colorBG
              })
              .then(
                data => {
                  this.page = data.data;
                  this.pageLoading = false;
                  this.$message.success('Главная страница успешно изменена!');
                },
                errorMessage => {
                  console.log(errorMessage);
                  this.$message.error('Ошибка перезаписи данных!');
                  this.pageLoading = false;
                }
              )
              .catch(() => {
                this.$message.error('Ошибка перезаписи данных');
                this.pageLoading = false;
              });
          }
        } else {
          this.$message.error('Пожалуйста, заполните все обязательные поля!');
          return false;
        }
      });
    }
  }
};
</script>
